#ifndef RLE_H
#define RLE_H

enum {
	rle_write = 0,
	rle_end   = 1,
	rle_init  = 2
};

void frleputc(unsigned char c, FILE *fout, unsigned char mode);
unsigned char rlegetc(void);

void frlewrite(void *data, size_t s, size_t n, FILE *f);
void frleread(void *data, size_t s, size_t n, FILE *f);


typedef enum
{
	rle_file,
	rle_pointer
} rle_source_type;

void rle_set_source(rle_source_type t, void *s);

#endif
